
/* i_SUB, i_SUBA, i_SUBX */

    case i_SUB:
      compile_ea(iib, ipc, tp_src, 1, &srcreg, -1);
      compile_eaval(iib, ipc, tp_src, srcreg, &srcval, TMP0);
      compile_ea(iib, ipc, tp_dst, 1, &dstreg, TMP1);
      compile_eaval(iib, ipc, tp_dst, dstreg, &dstval, -1);

      outval = 4; /* Use register 4 in case destination is a memory address */
      switch (iib->size) {
      case sz_byte:
        OPCODE = sub(outval, dstval, srcval);
        break;
      case sz_word:
        OPCODE = sub(outval, dstval, srcval);
        break;
      case sz_long:
        OPCODE = subc(outval, dstval, srcval);
        break;
      default:
        printf("i_SUB: Invalid size %d\n", iib->size);
        instr_error = 1;
      }

      if (ipc->set & IIB_FLAG_V)
        compile_subflag_v(iib, srcval, dstval, outval);
      if ((ipc->set & IIB_FLAG_C) || (ipc->set & IIB_FLAG_X))
        compile_subflag_cx(iib, srcval, dstval, outval);
      if (ipc->set & IIB_FLAG_N)
        compile_stdflag_n(iib, outval);
      if (ipc->set & IIB_FLAG_Z)
        compile_stdflag_z(iib, outval);

      compile_eastore(iib, ipc, tp_dst, dstreg, outval);
      break;

    case i_SUBA:
      compile_ea(iib, ipc, tp_src, 1, &srcreg, -1);
      compile_eaval(iib, ipc, tp_src, srcreg, &srcval, -1);
      compile_adval(iib, ipc, tp_dst, &outreg, -1);

      switch (iib->size) {
      case sz_word:
        OPCODE = extsh(srcval, srcval); /* Sign extend */
        break;
      case sz_long:
        break;
      default:
        printf("i_SUBA: Invalid size %d\n", iib->size);
        instr_error = 1;
      }

      OPCODE = sub(outreg, outreg, srcval);
      compile_adstore(iib, ipc, tp_dst, outreg);
      break;

    case i_SUBX:
      compile_ea(iib, ipc, tp_src, 1, &srcreg, -1);
      compile_eaval(iib, ipc, tp_src, srcreg, &srcval, TMP0);
      compile_ea(iib, ipc, tp_dst, 1, &dstreg, TMP1);
      compile_eaval(iib, ipc, tp_dst, dstreg, &dstval, -1);

      outval = 4; /* Use register 4 in case destination is a memory address */
      switch (iib->size) {
      case sz_byte:
        OPCODE = rlwinm(0, SRREG, 12, 31, 31);
        OPCODE = sub(outval, dstval, 0);
        OPCODE = sub(outval, outval, srcval);
        break;
      case sz_word:
        OPCODE = rlwinm(0, SRREG, 12, 31, 31);
        OPCODE = sub(outval, dstval, 0);
        OPCODE = sub(outval, outval, srcval);
        break;
      case sz_long:
        OPCODE = rlwinm(0, SRREG, 12, 31, 31);
        OPCODE = subc(outval, dstval, 0);
        if ((ipc->set & IIB_FLAG_C) || (ipc->set & IIB_FLAG_X)) {
          OPCODE = li(0, 0);
          OPCODE = addze(0, 0);
        }
        OPCODE = subc(outval, outval, srcval);
        if ((ipc->set & IIB_FLAG_C) || (ipc->set & IIB_FLAG_X)) {
          OPCODE = addze(0, 0);
          OPCODE = rlwimi(SRREG, 0, 16, 15, 15);
          OPCODE = rlwimi(SRREG, 0, 20, 11, 11);
        }
        break;
      default:
        printf("i_SUBX: Invalid size %d\n", iib->size);
        instr_error = 1;
      }

      if (ipc->set & IIB_FLAG_V)
        compile_subflag_v(iib, srcval, dstval, outval);
      if (iib->size != sz_long) {
        if ((ipc->set & IIB_FLAG_C) || (ipc->set & IIB_FLAG_X))
          compile_subflag_cx(iib, srcval, dstval, outval);
      }
      if (ipc->set & IIB_FLAG_N)
        compile_stdflag_n(iib, outval);
      if (ipc->set & IIB_FLAG_Z)
        compile_stdxflag_z(iib, outval);

      compile_eastore(iib, ipc, tp_dst, dstreg, outval);
      break;

