
/* i_ASR, i_LSR, i_ROXR, i_ROR */

    case i_ASR:
      compile_ea(iib, ipc, tp_src, 1, &srcreg, -1);
      compile_eaval(iib, ipc, tp_src, srcreg, &srcval, TMP0);
      compile_ea(iib, ipc, tp_dst, 1, &dstreg, TMP1);
      compile_eaval(iib, ipc, tp_dst, dstreg, &dstval, -1);
      outval = 4;

      OPCODE = andi_(3, srcval, 63);
      tmp = ptr;
      OPCODE = nop();

      switch (iib->size) {
      case sz_byte:
        OPCODE = extsb(dstval, dstval);
        OPCODE = sraw(outval, dstval, 3);
        break;
      case sz_word:
        OPCODE = extsh(dstval, dstval);
        OPCODE = sraw(outval, dstval, 3);
        break;
      case sz_long:
        OPCODE = sraw(outval, dstval, 3);
        break;
      default:
        printf("i_ASR: Invalid size %d\n", iib->size);
        instr_error = 1;
        break;
      }

      if ((ipc->set & IIB_FLAG_C) || (ipc->set & IIB_FLAG_X)) {
        OPCODE = subi(3, 3, 1);
        OPCODE = sraw(5, dstval, 3);

        if (ipc->set & IIB_FLAG_C)
        OPCODE = rlwimi(SRREG, 5, 16, 15, 15); /* CFLAG */
        if (ipc->set & IIB_FLAG_X)
        OPCODE = rlwimi(SRREG, 5, 20, 11, 11); /* XFLAG */
      }

      if (ipc->set & IIB_FLAG_V)
        compile_clrflag_v(iib);
      if (ipc->set & IIB_FLAG_N)
        compile_stdflag_n(iib, outval);
      if (ipc->set & IIB_FLAG_Z)
        compile_stdflag_z(iib, outval);

      compile_eastore(iib, ipc, tp_dst, dstreg, outval);

      end = ptr;
      OPCODE = nop();

      /* ZERO shift */
      *((uint32 *)tmp) = beq(ptr - tmp);

      if (ipc->set & IIB_FLAG_C)
        compile_clrflag_c(iib);
      if (ipc->set & IIB_FLAG_V)
        compile_clrflag_v(iib);
      if (ipc->set & IIB_FLAG_N)
        compile_stdflag_n(iib, dstval);
      if (ipc->set & IIB_FLAG_Z)
        compile_stdflag_z(iib, dstval);

      /* END */
      *((uint32 *)end) = b(ptr - end);
      break;

    case i_LSR:
      compile_ea(iib, ipc, tp_src, 1, &srcreg, -1);
      compile_eaval(iib, ipc, tp_src, srcreg, &srcval, TMP0);
      compile_ea(iib, ipc, tp_dst, 1, &dstreg, TMP1);
      compile_eaval(iib, ipc, tp_dst, dstreg, &dstval, -1);
      outval = 4;

      OPCODE = andi_(3, srcval, 63);
      tmp = ptr;
      OPCODE = nop();

      OPCODE = srw(outval, dstval, 3);

      if ((ipc->set & IIB_FLAG_C) || (ipc->set & IIB_FLAG_X)) {
        OPCODE = subi(3, 3, 1);
        OPCODE = srw(5, dstval, 3);

        if (ipc->set & IIB_FLAG_C)
        OPCODE = rlwimi(SRREG, 5, 16, 15, 15); /* CFLAG */
        if (ipc->set & IIB_FLAG_X)
        OPCODE = rlwimi(SRREG, 5, 20, 11, 11); /* XFLAG */
      }

      if (ipc->set & IIB_FLAG_V)
        compile_clrflag_v(iib);
      if (ipc->set & IIB_FLAG_N)
        compile_stdflag_n(iib, outval);
      if (ipc->set & IIB_FLAG_Z)
        compile_stdflag_z(iib, outval);

      compile_eastore(iib, ipc, tp_dst, dstreg, outval);

      end = ptr;
      OPCODE = nop();

      /* ZERO shift */
      *((uint32 *)tmp) = beq(ptr - tmp);

      if (ipc->set & IIB_FLAG_C)
        compile_clrflag_c(iib);
      if (ipc->set & IIB_FLAG_V)
        compile_clrflag_v(iib);
      if (ipc->set & IIB_FLAG_N)
        compile_stdflag_n(iib, dstval);
      if (ipc->set & IIB_FLAG_Z)
        compile_stdflag_z(iib, dstval);

      /* END */
      *((uint32 *)end) = b(ptr - end);
      break;

    case i_ROXR:
      compile_ea(iib, ipc, tp_src, 1, &srcreg, -1);
      compile_eaval(iib, ipc, tp_src, srcreg, &srcval, TMP0);
      compile_ea(iib, ipc, tp_dst, 1, &dstreg, TMP1);
      compile_eaval(iib, ipc, tp_dst, dstreg, &dstval, -1);
      outval = 4;

      OPCODE = andi_(3, srcval, 63);

      switch (iib->size) {
      case sz_byte:
        OPCODE = cmpwi(0, 3, 9);
        OPCODE = bltL(3*4);
        OPCODE = subi(3, 3, 9);
        OPCODE = b(-3*4);
        break;
      case sz_word:
        OPCODE = cmpwi(0, 3, 17);
        OPCODE = bltL(3*4);
        OPCODE = subi(3, 3, 17);
        OPCODE = b(-3*4);
        break;
      case sz_long:
        OPCODE = cmpwi(0, 3, 33);
        OPCODE = bltL(3*4);
        OPCODE = subi(3, 3, 33);
        OPCODE = b(-3*4);
        break;
      default:
        printf("i_ROXR: Invalid size %d\n", iib->size);
        instr_error = 1;
        break;
      }

      OPCODE = cmpwi(0, 3, 0);
      tmp = ptr;
      OPCODE = nop();

      switch (iib->size) {
      case sz_byte:
        OPCODE = rlwinm(outval, dstval,  0, 24, 31);
        OPCODE = rlwimi(outval, outval,  9, 15, 22);
        OPCODE = rlwimi(outval, SRREG,  20, 23, 23); /* XFLAG */

        OPCODE = subfic(3, 3, 32);
        OPCODE = rlwnm(outval, outval, 3, 0, 31);

        if (ipc->set & IIB_FLAG_C)
        OPCODE = rlwimi(SRREG, outval, 17, 15, 15); /* CFLAG */
        if (ipc->set & IIB_FLAG_X)
        OPCODE = rlwimi(SRREG, outval, 21, 11, 11); /* XFLAG */
        break;
      case sz_word:
        OPCODE = rlwinm(outval, dstval,  0, 16, 31);
        OPCODE = rlwimi(outval, outval, 16,  0, 15);

        if ((ipc->set & IIB_FLAG_C) || (ipc->set & IIB_FLAG_X)) {
          OPCODE = rlwinm(5, outval, 0, 16, 31);
          OPCODE = rlwimi(5, SRREG, 28, 15, 15); /* XFLAG */
        }

        OPCODE = rlwimi(outval, outval, 31, 17, 31);
        OPCODE = subi(3, 3, 1);
        OPCODE = rlwimi(outval, SRREG, 27, 16, 16); /* XFLAG */

        OPCODE = subfic(3, 3, 32);
        OPCODE = rlwnm(outval, outval, 3, 0, 31);

        if ((ipc->set & IIB_FLAG_C) || (ipc->set & IIB_FLAG_X)) {
          OPCODE = rlwnm(5, 5, 3, 0, 31);
        }

        if (ipc->set & IIB_FLAG_C)
        OPCODE = rlwimi(SRREG, 5, 16, 15, 15); /* CFLAG */
        if (ipc->set & IIB_FLAG_X)
        OPCODE = rlwimi(SRREG, 5, 20, 11, 11); /* XFLAG */
        break;
      case sz_long:
        OPCODE = subfic(4, 3, 32);
        OPCODE = subfic(5, 3, 33);
        OPCODE = rlwinm(0, SRREG, 12, 31, 31); /* XFLAG */
        OPCODE = subi(3, 3, 1);
        OPCODE = slw(4, 0, 4);
        OPCODE = slw(5, dstval, 5);
        OPCODE = srw(6, dstval, 3);

        if (ipc->set & IIB_FLAG_C)
        OPCODE = rlwimi(SRREG, 6, 16, 15, 15); /* CFLAG */
        if (ipc->set & IIB_FLAG_X)
        OPCODE = rlwimi(SRREG, 6, 20, 11, 11); /* XFLAG */

        OPCODE = or(4, 4, 5);
        OPCODE = rlwinm(6, 6, 31, 1, 31);
        OPCODE = or(outval, 6, 4);
        break;
      default:
        printf("i_ROXR: Invalid size %d\n", iib->size);
        instr_error = 1;
        break;
      }

      if (ipc->set & IIB_FLAG_V)
        compile_clrflag_v(iib);
      if (ipc->set & IIB_FLAG_N)
        compile_stdflag_n(iib, outval);
      if (ipc->set & IIB_FLAG_Z)
        compile_stdflag_z(iib, outval);

      compile_eastore(iib, ipc, tp_dst, dstreg, outval);

      end = ptr;
      OPCODE = nop();

      /* ZERO rotate */
      *((uint32 *)tmp) = beq(ptr - tmp);

      if (ipc->set & IIB_FLAG_C)
        OPCODE = rlwimi(SRREG, SRREG, 28, 15, 15); /* CFLAG = XFLAG */
      if (ipc->set & IIB_FLAG_V)
        compile_clrflag_v(iib);
      if (ipc->set & IIB_FLAG_N)
        compile_stdflag_n(iib, dstval);
      if (ipc->set & IIB_FLAG_Z)
        compile_stdflag_z(iib, dstval);

      /* END */
      *((uint32 *)end) = b(ptr - end);
      break;

    case i_ROR:
      compile_ea(iib, ipc, tp_src, 1, &srcreg, -1);
      compile_eaval(iib, ipc, tp_src, srcreg, &srcval, TMP0);
      compile_ea(iib, ipc, tp_dst, 1, &dstreg, TMP1);
      compile_eaval(iib, ipc, tp_dst, dstreg, &dstval, -1);
      outval = 4;

#if 0

      switch (iib->size) {
      case sz_byte:
        OPCODE = andi_(3, srcval,  7);
        break;
      case sz_word:
        OPCODE = andi_(3, srcval, 15);
        break;
      case sz_long:
        OPCODE = andi_(3, srcval, 31);
        break;
      default:
        printf("i_ROR: Invalid size %d\n", iib->size);
        instr_error = 1;
        break;
      }

      tmp = ptr;
      OPCODE = nop();

#else

      OPCODE = andi_(3, srcval, 63);
      tmp = ptr;
      OPCODE = nop();

#endif

      OPCODE = subfic(3, 3, 64);

      switch (iib->size) {
      case sz_byte:
        OPCODE = rlwinm(outval, dstval,  0, 24, 31);
        OPCODE = rlwimi(outval, outval,  8, 16, 23);
        OPCODE = rlwimi(outval, outval, 16,  0, 15);
        OPCODE = rlwnm(outval, outval, 3, 0, 31);
        if (ipc->set & IIB_FLAG_C)
        OPCODE = rlwimi(SRREG, outval, 17, 15, 15); /* CFLAG */
        break;
      case sz_word:
        OPCODE = rlwinm(outval, dstval,  0, 16, 31);
        OPCODE = rlwimi(outval, outval, 16,  0, 15);
        OPCODE = rlwnm(outval, outval, 3, 0, 31);
        if (ipc->set & IIB_FLAG_C)
        OPCODE = rlwimi(SRREG, outval, 17, 15, 15); /* CFLAG */
        break;
      case sz_long:
        OPCODE = rlwnm(outval, dstval, 3, 0, 31);
        if (ipc->set & IIB_FLAG_C)
        OPCODE = rlwimi(SRREG, outval, 17, 15, 15); /* CFLAG */
        break;
      default:
        printf("i_ROR: Invalid size %d\n", iib->size);
        instr_error = 1;
        break;
      }

      if (ipc->set & IIB_FLAG_V)
        compile_clrflag_v(iib);
      if (ipc->set & IIB_FLAG_N)
        compile_stdflag_n(iib, outval);
      if (ipc->set & IIB_FLAG_Z)
        compile_stdflag_z(iib, outval);

      compile_eastore(iib, ipc, tp_dst, dstreg, outval);

      end = ptr;
      OPCODE = nop();

      /* ZERO rotate */
      *((uint32 *)tmp) = beq(ptr - tmp);

      if (ipc->set & IIB_FLAG_C)
        compile_clrflag_c(iib);
      if (ipc->set & IIB_FLAG_V)
        compile_clrflag_v(iib);
      if (ipc->set & IIB_FLAG_N)
        compile_stdflag_n(iib, dstval);
      if (ipc->set & IIB_FLAG_Z)
        compile_stdflag_z(iib, dstval);

      /* END */
      *((uint32 *)end) = b(ptr - end);
      break;

