
/* i_ASL, i_LSL, i_ROXL, i_ROL */

    case i_ASL:
      compile_ea(iib, ipc, tp_src, 1, &srcreg, -1);
      compile_eaval(iib, ipc, tp_src, srcreg, &srcval, TMP0);
      compile_ea(iib, ipc, tp_dst, 1, &dstreg, TMP1);
      compile_eaval(iib, ipc, tp_dst, dstreg, &dstval, -1);
      outval = 4;

      OPCODE = andi_(3, srcval, 63);
      tmp = ptr;
      OPCODE = nop();

      OPCODE = slw(outval, dstval, 3);

      if ((ipc->set & IIB_FLAG_C) || (ipc->set & IIB_FLAG_X) || (ipc->set & IIB_FLAG_V)) {
        OPCODE = subi(3, 3, 1);
      }

      if ((ipc->set & IIB_FLAG_C) || (ipc->set & IIB_FLAG_X)) {
        OPCODE = slw(5, dstval, 3);

        switch (iib->size) {
        case sz_byte:
          if (ipc->set & IIB_FLAG_C)
          OPCODE = rlwimi(SRREG, 5,  9, 15, 15); /* CFLAG */
          if (ipc->set & IIB_FLAG_X)
          OPCODE = rlwimi(SRREG, 5, 13, 11, 11); /* XFLAG */
          break;
        case sz_word:
          if (ipc->set & IIB_FLAG_C)
          OPCODE = rlwimi(SRREG, 5,  1, 15, 15); /* CFLAG */
          if (ipc->set & IIB_FLAG_X)
          OPCODE = rlwimi(SRREG, 5,  5, 11, 11); /* XFLAG */
          break;
        case sz_long:
          if (ipc->set & IIB_FLAG_C)
          OPCODE = rlwimi(SRREG, 5, 17, 15, 15); /* CFLAG */
          if (ipc->set & IIB_FLAG_X)
          OPCODE = rlwimi(SRREG, 5, 21, 11, 11); /* XFLAG */
          break;
        default:
          printf("i_ASL: Invalid size %d\n", iib->size);
          instr_error = 1;
          break;
        }
      }

      /* MSB of result should be the same as ALL bits shifted out */
      if (ipc->set & IIB_FLAG_V) {
        switch (iib->size) {
        case sz_byte:
          OPCODE = lis(0, 0x8000);
          OPCODE = rlwinm(5, outval, 24, 0, 7);
          OPCODE = sraw(0, 0, 3);
          OPCODE = sraw(5, 5, 3);
          OPCODE = rlwinm(3, dstval, 24, 0, 7);
          OPCODE = xor(5, 3, 5);
          OPCODE = and(0, 5, 0);
          OPCODE = cntlzw(0, 0);
          OPCODE = xori(0, 0, 32);
          OPCODE = rlwimi(SRREG, 0, 12, 14, 14); /* VFLAG */
          break;
        case sz_word:
          OPCODE = lis(0, 0x8000);
          OPCODE = rlwinm(5, outval, 16, 0, 15);
          OPCODE = sraw(0, 0, 3);
          OPCODE = sraw(5, 5, 3);
          OPCODE = rlwinm(3, dstval, 16, 0, 15);
          OPCODE = xor(5, 3, 5);
          OPCODE = and(0, 5, 0);
          OPCODE = cntlzw(0, 0);
          OPCODE = xori(0, 0, 32);
          OPCODE = rlwimi(SRREG, 0, 12, 14, 14); /* VFLAG */
          break;
        case sz_long:
          OPCODE = lis(0, 0x8000);
          OPCODE = sraw(0, 0, 3);
          OPCODE = sraw(5, outval, 3);
          OPCODE = xor(5, dstval, 5);
          OPCODE = and(0, 5, 0);
          OPCODE = cntlzw(0, 0);
          OPCODE = xori(0, 0, 32);
          OPCODE = rlwimi(SRREG, 0, 12, 14, 14); /* VFLAG */
          break;
        default:
          printf("i_ASL: Invalid size %d\n", iib->size);
          instr_error = 1;
          break;
        }
      }

      if (ipc->set & IIB_FLAG_N)
        compile_stdflag_n(iib, outval);
      if (ipc->set & IIB_FLAG_Z)
        compile_stdflag_z(iib, outval);

      compile_eastore(iib, ipc, tp_dst, dstreg, outval);

      end = ptr;
      OPCODE = nop();

      /* ZERO shift */
      *((uint32 *)tmp) = beq(ptr - tmp);

      if (ipc->set & IIB_FLAG_C)
        compile_clrflag_c(iib);
      if (ipc->set & IIB_FLAG_V)
        compile_clrflag_v(iib);
      if (ipc->set & IIB_FLAG_N)
        compile_stdflag_n(iib, dstval);
      if (ipc->set & IIB_FLAG_Z)
        compile_stdflag_z(iib, dstval);

      /* END */
      *((uint32 *)end) = b(ptr - end);
      break;

    case i_LSL:
      compile_ea(iib, ipc, tp_src, 1, &srcreg, -1);
      compile_eaval(iib, ipc, tp_src, srcreg, &srcval, TMP0);
      compile_ea(iib, ipc, tp_dst, 1, &dstreg, TMP1);
      compile_eaval(iib, ipc, tp_dst, dstreg, &dstval, -1);
      outval = 4;

      OPCODE = andi_(3, srcval, 63);
      tmp = ptr;
      OPCODE = nop();

      OPCODE = slw(outval, dstval, 3);

      if ((ipc->set & IIB_FLAG_C) || (ipc->set & IIB_FLAG_X)) {
        OPCODE = subi(3, 3, 1);
        OPCODE = slw(5, dstval, 3);

        switch (iib->size) {
        case sz_byte:
          if (ipc->set & IIB_FLAG_C)
          OPCODE = rlwimi(SRREG, 5,  9, 15, 15); /* CFLAG */
          if (ipc->set & IIB_FLAG_X)
          OPCODE = rlwimi(SRREG, 5, 13, 11, 11); /* XFLAG */
          break;
        case sz_word:
          if (ipc->set & IIB_FLAG_C)
          OPCODE = rlwimi(SRREG, 5,  1, 15, 15); /* CFLAG */
          if (ipc->set & IIB_FLAG_X)
          OPCODE = rlwimi(SRREG, 5,  5, 11, 11); /* XFLAG */
          break;
        case sz_long:
          if (ipc->set & IIB_FLAG_C)
          OPCODE = rlwimi(SRREG, 5, 17, 15, 15); /* CFLAG */
          if (ipc->set & IIB_FLAG_X)
          OPCODE = rlwimi(SRREG, 5, 21, 11, 11); /* XFLAG */
          break;
        default:
          printf("i_LSL: Invalid size %d\n", iib->size);
          instr_error = 1;
          break;
        }
      }

      if (ipc->set & IIB_FLAG_V)
        compile_clrflag_v(iib);
      if (ipc->set & IIB_FLAG_N)
        compile_stdflag_n(iib, outval);
      if (ipc->set & IIB_FLAG_Z)
        compile_stdflag_z(iib, outval);

      compile_eastore(iib, ipc, tp_dst, dstreg, outval);

      end = ptr;
      OPCODE = nop();

      /* ZERO shift */
      *((uint32 *)tmp) = beq(ptr - tmp);

      if (ipc->set & IIB_FLAG_C)
        compile_clrflag_c(iib);
      if (ipc->set & IIB_FLAG_V)
        compile_clrflag_v(iib);
      if (ipc->set & IIB_FLAG_N)
        compile_stdflag_n(iib, dstval);
      if (ipc->set & IIB_FLAG_Z)
        compile_stdflag_z(iib, dstval);

      /* END */
      *((uint32 *)end) = b(ptr - end);
      break;

    case i_ROXL:
      compile_ea(iib, ipc, tp_src, 1, &srcreg, -1);
      compile_eaval(iib, ipc, tp_src, srcreg, &srcval, TMP0);
      compile_ea(iib, ipc, tp_dst, 1, &dstreg, TMP1);
      compile_eaval(iib, ipc, tp_dst, dstreg, &dstval, -1);
      outval = 4;

      OPCODE = andi_(3, srcval, 63);

      switch (iib->size) {
      case sz_byte:
        OPCODE = cmpwi(0, 3, 9);
        OPCODE = bltL(3*4);
        OPCODE = subi(3, 3, 9);
        OPCODE = b(-3*4);
        break;
      case sz_word:
        OPCODE = cmpwi(0, 3, 17);
        OPCODE = bltL(3*4);
        OPCODE = subi(3, 3, 17);
        OPCODE = b(-3*4);
        break;
      case sz_long:
        OPCODE = cmpwi(0, 3, 33);
        OPCODE = bltL(3*4);
        OPCODE = subi(3, 3, 33);
        OPCODE = b(-3*4);
        break;
      default:
        printf("i_ROXL: Invalid size %d\n", iib->size);
        instr_error = 1;
        break;
      }

      OPCODE = cmpwi(0, 3, 0);
      tmp = ptr;
      OPCODE = nop();

      switch (iib->size) {
      case sz_byte:
        OPCODE = rlwinm(outval, dstval,  0, 24, 31);
        OPCODE = rlwimi(outval, outval, 23,  1,  8);
        OPCODE = rlwimi(outval, SRREG,  11,  0,  0); /* XFLAG */

        OPCODE = rlwnm(outval, outval, 3, 0, 31);

        if (ipc->set & IIB_FLAG_C)
        OPCODE = rlwimi(SRREG, outval, 8, 15, 15); /* CFLAG */
        if (ipc->set & IIB_FLAG_X)
        OPCODE = rlwimi(SRREG, outval, 12, 11, 11); /* XFLAG */
        break;
      case sz_word:
        OPCODE = rlwinm(outval, dstval,  0, 16, 31);
        OPCODE = rlwimi(outval, outval, 16,  0, 15);

        if ((ipc->set & IIB_FLAG_C) || (ipc->set & IIB_FLAG_X)) {
          OPCODE = rlwinm(5, outval, 16, 0, 15);
          OPCODE = rlwimi(5, SRREG, 27, 16, 16); /* XFLAG */
        }

        OPCODE = rlwimi(outval, outval, 1, 16, 30);
        OPCODE = subi(3, 3, 1);
        OPCODE = rlwimi(outval, SRREG, 12, 31, 31); /* XFLAG */
        OPCODE = rlwnm(outval, outval, 3, 0, 31);

        if ((ipc->set & IIB_FLAG_C) || (ipc->set & IIB_FLAG_X)) {
          OPCODE = rlwnm(5, 5, 3, 0, 31);
        }

        if (ipc->set & IIB_FLAG_C)
        OPCODE = rlwimi(SRREG, 5, 17, 15, 15); /* CFLAG */
        if (ipc->set & IIB_FLAG_X)
        OPCODE = rlwimi(SRREG, 5, 21, 11, 11); /* XFLAG */
        break;
      case sz_long:
        OPCODE = subfic(5, 3, 33);
        OPCODE = rlwinm(0, SRREG, 12, 31, 31); /* XFLAG */
        OPCODE = subi(3, 3, 1);
        OPCODE = slw(0, 0, 3);
        OPCODE = srw(4, dstval, 5);
        OPCODE = slw(6, dstval, 3);

        if (ipc->set & IIB_FLAG_C)
        OPCODE = rlwimi(SRREG, 6, 17, 15, 15); /* CFLAG */
        if (ipc->set & IIB_FLAG_X)
        OPCODE = rlwimi(SRREG, 6, 21, 11, 11); /* XFLAG */

        OPCODE = or(0, 0, 4);
        OPCODE = rlwinm(6, 6, 1, 0, 30);
        OPCODE = or(outval, 6, 0);
        break;
      default:
        printf("i_ROXL: Invalid size %d\n", iib->size);
        instr_error = 1;
        break;
      }

      if (ipc->set & IIB_FLAG_V)
        compile_clrflag_v(iib);
      if (ipc->set & IIB_FLAG_N)
        compile_stdflag_n(iib, outval);
      if (ipc->set & IIB_FLAG_Z)
        compile_stdflag_z(iib, outval);

      compile_eastore(iib, ipc, tp_dst, dstreg, outval);

      end = ptr;
      OPCODE = nop();

      /* ZERO rotate */
      *((uint32 *)tmp) = beq(ptr - tmp);

      if (ipc->set & IIB_FLAG_C)
        OPCODE = rlwimi(SRREG, SRREG, 28, 15, 15); /* CFLAG = XFLAG */
      if (ipc->set & IIB_FLAG_V)
        compile_clrflag_v(iib);
      if (ipc->set & IIB_FLAG_N)
        compile_stdflag_n(iib, dstval);
      if (ipc->set & IIB_FLAG_Z)
        compile_stdflag_z(iib, dstval);

      /* END */
      *((uint32 *)end) = b(ptr - end);
      break;

    case i_ROL:
      compile_ea(iib, ipc, tp_src, 1, &srcreg, -1);
      compile_eaval(iib, ipc, tp_src, srcreg, &srcval, TMP0);
      compile_ea(iib, ipc, tp_dst, 1, &dstreg, TMP1);
      compile_eaval(iib, ipc, tp_dst, dstreg, &dstval, -1);
      outval = 4;

#if 0

      switch (iib->size) {
      case sz_byte:
        OPCODE = andi_(3, srcval,  7);
        break;
      case sz_word:
        OPCODE = andi_(3, srcval, 15);
        break;
      case sz_long:
        OPCODE = andi_(3, srcval, 31);
        break;
      default:
        printf("i_ROL: Invalid size %d\n", iib->size);
        instr_error = 1;
        break;
      }

      tmp = ptr;
      OPCODE = nop();

#else

      OPCODE = andi_(3, srcval, 63);
      tmp = ptr;
      OPCODE = nop();

#endif

      switch (iib->size) {
      case sz_byte:
        OPCODE = rlwinm(outval, dstval,  0, 24, 31);
        OPCODE = rlwimi(outval, outval,  8, 16, 23);
        OPCODE = rlwimi(outval, outval, 16,  0, 15);
        OPCODE = rlwnm(outval, outval, 3, 0, 31);
        if (ipc->set & IIB_FLAG_C)
        OPCODE = rlwimi(SRREG, outval, 8, 15, 15); /* CFLAG */
        break;
      case sz_word:
        OPCODE = rlwinm(outval, dstval,  0, 16, 31);
        OPCODE = rlwimi(outval, outval, 16,  0, 15);
        OPCODE = rlwnm(outval, outval, 3, 0, 31);
        if (ipc->set & IIB_FLAG_C)
        OPCODE = rlwimi(SRREG, outval, 0, 15, 15); /* CFLAG */
        break;
      case sz_long:
        OPCODE = rlwnm(outval, dstval, 3, 0, 31);
        if (ipc->set & IIB_FLAG_C)
        OPCODE = rlwimi(SRREG, outval, 16, 15, 15); /* CFLAG */
        break;
      default:
        printf("i_ROL: Invalid size %d\n", iib->size);
        instr_error = 1;
        break;
      }

      if (ipc->set & IIB_FLAG_V)
        compile_clrflag_v(iib);
      if (ipc->set & IIB_FLAG_N)
        compile_stdflag_n(iib, outval);
      if (ipc->set & IIB_FLAG_Z)
        compile_stdflag_z(iib, outval);

      compile_eastore(iib, ipc, tp_dst, dstreg, outval);

      end = ptr;
      OPCODE = nop();

      /* ZERO rotate */
      *((uint32 *)tmp) = beq(ptr - tmp);

      if (ipc->set & IIB_FLAG_C)
        compile_clrflag_c(iib);
      if (ipc->set & IIB_FLAG_V)
        compile_clrflag_v(iib);
      if (ipc->set & IIB_FLAG_N)
        compile_stdflag_n(iib, dstval);
      if (ipc->set & IIB_FLAG_Z)
        compile_stdflag_z(iib, dstval);

      /* END */
      *((uint32 *)end) = b(ptr - end);
      break;

