
/* i_NEG, i_NEGX, i_CLR, i_NOT */

    case i_NEG:
      compile_ea(iib, ipc, tp_src, 1, &srcreg, TMP0);
      compile_eaval(iib, ipc, tp_src, srcreg, &srcval, -1);
      outval = 4;

      OPCODE = subfic(outval, srcval, 0);

      if (ipc->set & IIB_FLAG_V)
        compile_negflag_v(iib, srcval, outval);
      if ((ipc->set & IIB_FLAG_C) || (ipc->set & IIB_FLAG_X))
        compile_negflag_cx(iib, outval);
      if (ipc->set & IIB_FLAG_N)
        compile_stdflag_n(iib, outval);
      if (ipc->set & IIB_FLAG_Z)
        compile_stdflag_z(iib, outval);

      compile_eastore(iib, ipc, tp_src, srcreg, outval);
      break;

    case i_NEGX:
      compile_ea(iib, ipc, tp_src, 1, &srcreg, TMP0);
      compile_eaval(iib, ipc, tp_src, srcreg, &srcval, -1);
      outval = 4;

      OPCODE = subfic(outval, srcval, 0);
      OPCODE = rlwinm(0, SRREG, 12, 31, 31);
      OPCODE = sub(outval, outval, 0);

      if (ipc->set & IIB_FLAG_V)
        compile_negxflag_v(iib, srcval, outval);
      if ((ipc->set & IIB_FLAG_C) || (ipc->set & IIB_FLAG_X))
        compile_negxflag_cx(iib, srcval, outval);
      if (ipc->set & IIB_FLAG_N)
        compile_stdflag_n(iib, outval);
      if (ipc->set & IIB_FLAG_Z)
        compile_stdxflag_z(iib, outval);

      compile_eastore(iib, ipc, tp_src, srcreg, outval);
      break;

    case i_CLR:
      compile_ea(iib, ipc, tp_src, 1, &srcreg, -1);
      compile_eaval(iib, ipc, tp_src, srcreg, &srcval, TMP0);

      outval = 4; /* Use register 4 in case destination is a memory address */
      switch (iib->size) {
      case sz_byte:
      case sz_word:
      case sz_long:
        OPCODE = li(outval, 0);
        break;
      default:
        printf("i_CLR: Invalid size %d\n", iib->size);
        instr_error = 1;
      }

      if (ipc->set & IIB_FLAG_V)
        compile_clrflag_v(iib);
      if (ipc->set & IIB_FLAG_C)
        compile_clrflag_c(iib);
      if (ipc->set & IIB_FLAG_N)
        compile_clrflag_n(iib);
      if (ipc->set & IIB_FLAG_Z)
        compile_setflag_z(iib);

      compile_eastore(iib, ipc, tp_src, srcreg, outval);
      break;

    case i_NOT:
      compile_ea(iib, ipc, tp_src, 1, &srcreg, TMP0);
      compile_eaval(iib, ipc, tp_src, srcreg, &srcval, -1);
      outval = 4;

      OPCODE = not(outval, srcval);

      if (ipc->set & IIB_FLAG_V)
        compile_clrflag_v(iib);
      if (ipc->set & IIB_FLAG_C)
        compile_clrflag_c(iib);
      if (ipc->set & IIB_FLAG_N)
        compile_stdflag_n(iib, outval);
      if (ipc->set & IIB_FLAG_Z)
        compile_stdflag_z(iib, outval);

      compile_eastore(iib, ipc, tp_src, srcreg, outval);
      break;

