
/*
typedef enum {
  i_ILLG,
  i_MOVEPMR, i_MOVEPRM,
  i_MOVEFSR, i_MOVETSR,
  i_MOVEMRM, i_MOVEMMR,
  i_MOVETUSP, i_MOVEFUSP,
  i_ABCD, i_SBCD, i_NBCD,
  i_TRAPV, i_TRAP, i_RESET, i_NOP, i_STOP,
  i_LINK, i_UNLK,
  i_RTE, i_RTS, i_RTR,
  i_JSR, i_JMP, i_Scc, i_SF, i_DBcc, i_DBRA, i_Bcc, i_BSR,
  i_LINE10, i_LINE15
} t_mnemonic;
*/

/* MISC */

    case i_NOP:
      break;

    case i_Bcc:
      srcval = get_work_reg(-1);
      compile_cc(iib, srcval, 5); /* 5 -> 0 or 32 */
#ifndef CC_TABLE
      OPCODE = xori(srcval, srcval, 32);
#endif
      dstval = ipc->src - (2*iib->wordlen) - addr68k;
      OPCODE = lis(0, ((uint32)dstval >> 16));
      OPCODE = ori(0, 0, ((uint32)dstval & 0xffff));
      OPCODE = slw(0, 0, srcval);

      OPCODE = add(PCREG, PCREG, 0);
      break;

    case i_DBRA:
      compile_ea(iib, ipc, tp_dst, 1, &dstreg, TMP0);
      compile_eaval(iib, ipc, tp_dst, dstreg, &dstval, -1);

      OPCODE = subi(0, dstval, 1);
      OPCODE = rlwimi(dstval, 0, 0, 16, 31);
      OPCODE = extsh(0, 0);
      compile_adstore(iib, ipc, tp_dst, dstval);
      OPCODE = cmpwi(0, 0, -1);
      OPCODE = beq(4*3);

      dstval = ipc->src - (2*iib->wordlen);
      OPCODE = lis(PCREG, ((uint32)dstval >> 16));
      OPCODE = ori(PCREG, PCREG, ((uint32)dstval & 0xffff));
      break;

    case i_JSR:
      compile_ea(iib, ipc, tp_src, 1, &srcreg, TMP0);
      OPCODE = lwz(5, ADDRREG(7), DAREG);
      OPCODE = subi(5, 5, 4);
      OPCODE = stw(5, ADDRREG(7), DAREG);

      OPCODE = addi(4, PCREG, (iib->wordlen)*2);

      OPCODE = rlwinm(3, 5, 0, 8, 31);
      OPCODE = lis(6, ((uint32)mem68k_store_long >> 16));
      OPCODE = ori(6, 6, ((uint32)mem68k_store_long & 0xffff));
      OPCODE = rlwinm(0, 3, 22, 18, 29);
      OPCODE = lwzx(0, 6, 0);
      OPCODE = mtlr(0);
      OPCODE = blrl();

      OPCODE = mr(PCREG, srcreg);

      pc_inc = 0;
      break;

    case i_JMP:
      compile_ea(iib, ipc, tp_src, 1, &srcreg, PCREG);

      pc_inc = 0;
      break;

    case i_RTS:
      OPCODE = lwz(5, ADDRREG(7), DAREG);

      OPCODE = rlwinm(3, 5, 0, 8, 31);
      OPCODE = lis(6, ((uint32)mem68k_fetch_long >> 16));
      OPCODE = ori(6, 6, ((uint32)mem68k_fetch_long & 0xffff));
      OPCODE = rlwinm(0, 3, 22, 18, 29);
      OPCODE = lwzx(0, 6, 0);
      OPCODE = mtlr(0);
      OPCODE = blrl();

      OPCODE = mr(PCREG, 3);

      OPCODE = lwz(5, ADDRREG(7), DAREG);
      OPCODE = addi(5, 5, 4);
      OPCODE = stw(5, ADDRREG(7), DAREG);

      pc_inc = 0;
      break;

    case i_BSR:
      OPCODE = lwz(5, ADDRREG(7), DAREG);
      OPCODE = subi(5, 5, 4);
      OPCODE = stw(5, ADDRREG(7), DAREG);

      OPCODE = addi(4, PCREG, (iib->wordlen)*2);

      OPCODE = rlwinm(3, 5, 0, 8, 31);
      OPCODE = lis(6, ((uint32)mem68k_store_long >> 16));
      OPCODE = ori(6, 6, ((uint32)mem68k_store_long & 0xffff));
      OPCODE = rlwinm(0, 3, 22, 18, 29);
      OPCODE = lwzx(0, 6, 0);
      OPCODE = mtlr(0);
      OPCODE = blrl();

      OPCODE = lis(PCREG, ((uint32)ipc->src >> 16));
      OPCODE = ori(PCREG, PCREG, ((uint32)ipc->src & 0xffff));

      pc_inc = 0;
      break;

    case i_MOVEFSR:
      compile_ea(iib, ipc, tp_src, 1, &srcreg, -1);
      outval = 4;
      OPCODE = rlwinm(outval, SRREG, 16, 16, 31);
      compile_eastore(iib, ipc, tp_src, srcreg, outval);
      break;

/* i_OR, i_ORSR */
/* i_AND, i_ANDSR */
/* i_EOR, i_EORSR */

    case i_OR:
    case i_AND:
    case i_EOR:
      compile_ea(iib, ipc, tp_src, 1, &srcreg, -1);
      compile_eaval(iib, ipc, tp_src, srcreg, &srcval, TMP0);
      compile_ea(iib, ipc, tp_dst, 1, &dstreg, TMP1);
      compile_eaval(iib, ipc, tp_dst, dstreg, &dstval, -1);

      outval = 4; /* Use register 4 in case destination is a memory address */
      switch(iib->mnemonic) {
      case i_OR:
        OPCODE = or(outval, dstval, srcval);
        break;
      case i_AND:
        OPCODE = and(outval, dstval, srcval);
        break;
      case i_EOR:
        OPCODE = xor(outval, dstval, srcval);
        break;
      default:
        printf("i_OR/i_AND/i_EOR: Invalid instruction\n");
        instr_error = 1;
      }

      if (ipc->set & IIB_FLAG_V)
        compile_clrflag_v(iib);
      if (ipc->set & IIB_FLAG_C)
        compile_clrflag_c(iib);
      if (ipc->set & IIB_FLAG_N)
        compile_stdflag_n(iib, outval);
      if (ipc->set & IIB_FLAG_Z)
        compile_stdflag_z(iib, outval);

      compile_eastore(iib, ipc, tp_dst, dstreg, outval);
      break;

/* i_CMP, i_CMPA */

    case i_CMP:
      compile_ea(iib, ipc, tp_src, 1, &srcreg, -1);
      compile_eaval(iib, ipc, tp_src, srcreg, &srcval, TMP0);
      compile_ea(iib, ipc, tp_dst, 1, &dstreg, TMP1);
      compile_eaval(iib, ipc, tp_dst, dstreg, &dstval, -1);

      outval = 4; /* Use register 4 in case destination is a memory address */
      switch (iib->size) {
      case sz_byte:
        OPCODE = sub(outval, dstval, srcval);
        break;
      case sz_word:
        OPCODE = sub(outval, dstval, srcval);
        break;
      case sz_long:
        OPCODE = subc(outval, dstval, srcval);
        break;
      default:
        printf("i_CMP: Invalid size %d\n", iib->size);
        instr_error = 1;
      }

      if (ipc->set & IIB_FLAG_V)
        compile_subflag_v(iib, srcval, dstval, outval);
      if (ipc->set & IIB_FLAG_C)
        compile_subflag_c(iib, srcval, dstval, outval);
      if (ipc->set & IIB_FLAG_N)
        compile_stdflag_n(iib, outval);
      if (ipc->set & IIB_FLAG_Z)
        compile_stdflag_z(iib, outval);
      break;

    case i_CMPA:
      compile_ea(iib, ipc, tp_src, 1, &srcreg, -1);
      compile_eaval(iib, ipc, tp_src, srcreg, &srcval, TMP0);
      compile_ea(iib, ipc, tp_dst, 1, &dstreg, TMP1);
      compile_eaval(iib, ipc, tp_dst, dstreg, &dstval, -1);

      outval = 4; /* Use register 4 in case destination is a memory address */
      switch (iib->size) {
      case sz_word:
        OPCODE = extsh(srcval, srcval); /* Sign extend */
        break;
      default:
        printf("i_CMPA: Invalid size %d\n", iib->size);
        instr_error = 1;
      }

      OPCODE = subc(outval, dstval, srcval);

      iib->size = sz_long;
      if (ipc->set & IIB_FLAG_V)
        compile_subflag_v(iib, srcval, dstval, outval);
      if (ipc->set & IIB_FLAG_C)
        compile_subflag_c(iib, srcval, dstval, outval);
      if (ipc->set & IIB_FLAG_N)
        compile_stdflag_n(iib, outval);
      if (ipc->set & IIB_FLAG_Z)
        compile_stdflag_z(iib, outval);
      iib->size = sz_word;
      break;

/* i_MULU, i_MULS */

    case i_MULU:
      compile_ea(iib, ipc, tp_src, 1, &srcreg, -1);
      compile_eaval(iib, ipc, tp_src, srcreg, &srcval, TMP0);
      compile_ea(iib, ipc, tp_dst, 1, &dstreg, TMP1);
      compile_eaval(iib, ipc, tp_dst, dstreg, &dstval, -1);

      outval = 4; /* Use register 4 in case destination is a memory address */

      OPCODE = mullw(outval, srcval, dstval);

      if (ipc->set & IIB_FLAG_N) {
        /* sz_long stdflag_n */
        OPCODE = rlwimi(SRREG, outval, 20, 12, 12);
      }
      if (ipc->set & IIB_FLAG_Z) {
        /* sz_long stdflag_z */
        OPCODE = cntlzw(0, outval);
        OPCODE = rlwimi(SRREG, 0, 13, 13, 13);
      }
      if (ipc->set & IIB_FLAG_V)
        compile_clrflag_v(iib);
      if (ipc->set & IIB_FLAG_C)
        compile_clrflag_c(iib);

      iib->size = sz_long;
      compile_eastore(iib, ipc, tp_dst, dstreg, outval);
      iib->size = sz_word;
      break;

    case i_MULS:
      compile_ea(iib, ipc, tp_src, 1, &srcreg, -1);
      compile_eaval(iib, ipc, tp_src, srcreg, &srcval, TMP0);
      compile_ea(iib, ipc, tp_dst, 1, &dstreg, TMP1);
      compile_eaval(iib, ipc, tp_dst, dstreg, &dstval, -1);

      outval = 4; /* Use register 4 in case destination is a memory address */

      OPCODE = extsh(srcval, srcval);
      OPCODE = extsh(dstval, dstval);
      OPCODE = mullw(outval, srcval, dstval);

      if (ipc->set & IIB_FLAG_N) {
        /* sz_long stdflag_n */
        OPCODE = rlwimi(SRREG, outval, 20, 12, 12);
      }
      if (ipc->set & IIB_FLAG_Z) {
        /* sz_long stdflag_z */
        OPCODE = cntlzw(0, outval);
        OPCODE = rlwimi(SRREG, 0, 13, 13, 13);
      }
      if (ipc->set & IIB_FLAG_V)
        compile_clrflag_v(iib);
      if (ipc->set & IIB_FLAG_C)
        compile_clrflag_c(iib);

      iib->size = sz_long;
      compile_eastore(iib, ipc, tp_dst, dstreg, outval);
      iib->size = sz_word;
      break;

/* i_DIVU, i_DIVS */

    case i_DIVU: {
      void *ove, *end0, *end1;

      compile_ea(iib, ipc, tp_src, 1, &srcreg, -1);
      compile_eaval(iib, ipc, tp_src, srcreg, &srcval, TMP0);
      iib->size = sz_long;
      compile_ea(iib, ipc, tp_dst, 1, &dstreg, TMP1);
      compile_eaval(iib, ipc, tp_dst, dstreg, &dstval, -1);
      iib->size = sz_word;

      outval = 4; /* Use register 4 in case destination is a memory address */

      OPCODE = rlwinm_(srcval, srcval, 0, 16, 31);
      tmp = ptr;
      OPCODE = nop();

      OPCODE = divwu(outval, dstval, srcval);

      OPCODE = rlwinm_(0, outval, 0, 0, 15);
      ove = ptr;
      OPCODE = nop();

      OPCODE = mullw(0, outval, srcval);
      OPCODE = sub(0, dstval, 0);
      OPCODE = rlwimi(outval, 0, 16, 0, 15);

      if (ipc->set & IIB_FLAG_V)
        compile_clrflag_v(iib);
      if (ipc->set & IIB_FLAG_C)
        compile_clrflag_c(iib);
      if (ipc->set & IIB_FLAG_N)
        compile_stdflag_n(iib, outval);
      if (ipc->set & IIB_FLAG_Z)
        compile_stdflag_z(iib, outval);

      iib->size = sz_long;
      compile_eastore(iib, ipc, tp_dst, dstreg, outval);
      iib->size = sz_word;

      end0 = ptr;
      OPCODE = nop();

      /* division by ZERO */
      *((uint32 *)tmp) = beq(ptr - tmp);

      OPCODE = li(3, V_ZERO);
      OPCODE = addi(4, PCREG, (iib->wordlen)*2);
      OPCODE = lis(0, ((uint32)&reg68k_internal_vector >> 16));
      OPCODE = ori(0, 0, ((uint32)&reg68k_internal_vector & 0xffff));
      OPCODE = mtlr(0);
      OPCODE = blrl();

      end1 = ptr;
      OPCODE = nop();

      /* division OVERFLOW */
      *((uint32 *)ove) = bne(ptr - ove);

      if (ipc->set & IIB_FLAG_V)
        compile_setflag_v(iib);
      if (ipc->set & IIB_FLAG_C)
        compile_clrflag_c(iib);

      /* END */
      *((uint32 *)end0) = b(ptr - end0);
      *((uint32 *)end1) = b(ptr - end1);
    } break;

    case i_DIVS: {
      void *ove0, *ove1, *no_ove, *end0, *end1;

      compile_ea(iib, ipc, tp_src, 1, &srcreg, -1);
      compile_eaval(iib, ipc, tp_src, srcreg, &srcval, TMP0);
      iib->size = sz_long;
      compile_ea(iib, ipc, tp_dst, 1, &dstreg, TMP1);
      compile_eaval(iib, ipc, tp_dst, dstreg, &dstval, -1);
      iib->size = sz_word;

      outval = 4; /* Use register 4 in case destination is a memory address */

      OPCODE = extsh_(srcval, srcval);
      tmp = ptr;
      OPCODE = nop();

      /* 0x80000000 / 0xffffffff will give an overflow and undefined result, handle it */
      OPCODE = divwo(outval, dstval, srcval);
      OPCODE = mfxer(0);
      OPCODE = rlwinm_(0, 0, 0, 1, 1); /* mask out OV bit */
      ove1 = ptr;
      OPCODE = nop();

      OPCODE = rlwinm_(0, outval, 0, 0, 16);
      no_ove = ptr;
      OPCODE = nop();

      OPCODE = not(0, outval);
      OPCODE = rlwinm_(0, 0, 0, 0, 16);
      ove0 = ptr;
      OPCODE = nop();

      /* NO division OVERFLOW */
      *((uint32 *)no_ove) = beq(ptr - no_ove);

      OPCODE = mullw(0, outval, srcval);
      OPCODE = sub(0, dstval, 0);
      OPCODE = rlwimi(outval, 0, 16, 0, 15);

      if (ipc->set & IIB_FLAG_V)
        compile_clrflag_v(iib);
      if (ipc->set & IIB_FLAG_C)
        compile_clrflag_c(iib);
      if (ipc->set & IIB_FLAG_N)
        compile_stdflag_n(iib, outval);
      if (ipc->set & IIB_FLAG_Z)
        compile_stdflag_z(iib, outval);

      iib->size = sz_long;
      compile_eastore(iib, ipc, tp_dst, dstreg, outval);
      iib->size = sz_word;

      end0 = ptr;
      OPCODE = nop();

      /* division by ZERO */
      *((uint32 *)tmp) = beq(ptr - tmp);

      OPCODE = li(3, V_ZERO);
      OPCODE = addi(4, PCREG, (iib->wordlen)*2);
      OPCODE = lis(0, ((uint32)&reg68k_internal_vector >> 16));
      OPCODE = ori(0, 0, ((uint32)&reg68k_internal_vector & 0xffff));
      OPCODE = mtlr(0);
      OPCODE = blrl();

      end1 = ptr;
      OPCODE = nop();

      /* division OVERFLOW */
      *((uint32 *)ove0) = bne(ptr - ove0);
      *((uint32 *)ove1) = bne(ptr - ove1);

      if (ipc->set & IIB_FLAG_V)
        compile_setflag_v(iib);
      if (ipc->set & IIB_FLAG_C)
        compile_clrflag_c(iib);

      /* END */
      *((uint32 *)end0) = b(ptr - end0);
      *((uint32 *)end1) = b(ptr - end1);
    } break;

/* i_MOVE, i_MOVEA */

    case i_MOVE:
      compile_ea(iib, ipc, tp_src, 1, &srcreg, -1);
      compile_eaval(iib, ipc, tp_src, srcreg, &srcval, -1);

      if (ipc->set & IIB_FLAG_V)
        compile_clrflag_v(iib);
      if (ipc->set & IIB_FLAG_C)
        compile_clrflag_c(iib);
      if (ipc->set & IIB_FLAG_N)
        compile_stdflag_n(iib, srcval);
      if (ipc->set & IIB_FLAG_Z)
        compile_stdflag_z(iib, srcval);

      compile_ea(iib, ipc, tp_dst, 1, &dstreg, -1);
      compile_eastore(iib, ipc, tp_dst, dstreg, srcval);
      break;

    case i_MOVEA:
      compile_ea(iib, ipc, tp_src, 1, &srcreg, -1);
      compile_eaval(iib, ipc, tp_src, srcreg, &srcval, -1);
      switch (iib->size) {
      case sz_word:
        OPCODE = extsh(srcval, srcval); /* Sign extend */
        break;
      case sz_long:
        break;
      default:
        printf("i_MOVEA: Invalid size %d\n", iib->size);
        instr_error = 1;
      }

      compile_adstore(iib, ipc, tp_dst, srcval);
      break;

/* i_SWAP */

    case i_SWAP:
      compile_ea(iib, ipc, tp_src, 1, &srcreg, TMP0);
      compile_eaval(iib, ipc, tp_src, srcreg, &srcval, -1);
      outval = 4;

      OPCODE = rlwinm(outval, srcval, 16, 0, 31); /* ABCD -> CDAB */

      if (ipc->set & IIB_FLAG_V)
        compile_clrflag_v(iib);
      if (ipc->set & IIB_FLAG_C)
        compile_clrflag_c(iib);
      if (ipc->set & IIB_FLAG_N)
        compile_stdflag_n(iib, outval);
      if (ipc->set & IIB_FLAG_Z)
        compile_stdflag_z(iib, outval);

      compile_eastore(iib, ipc, tp_src, srcreg, outval);
      break;

/* i_PEA, i_LEA */

    case i_LEA:
      compile_ea(iib, ipc, tp_src, 1, &srcreg, -1);
      compile_adstore(iib, ipc, tp_dst, srcreg);
      break;

/* i_EXT, i_EXG */

    case i_EXT:
      compile_ea(iib, ipc, tp_src, 1, &srcreg, TMP0);
      compile_eaval(iib, ipc, tp_src, srcreg, &srcval, -1);
      outval = 4;

      switch(iib->size) {
      case sz_word:
        OPCODE = extsb(outval, srcval);
        break;
      case sz_long:
        OPCODE = extsh(outval, srcval);
        break;
      default:
        printf("i_EXT: Invalid size %d\n", iib->size);
        instr_error = 1;
        break;
      }

      if (ipc->set & IIB_FLAG_V)
        compile_clrflag_v(iib);
      if (ipc->set & IIB_FLAG_C)
        compile_clrflag_c(iib);
      if (ipc->set & IIB_FLAG_N)
        compile_stdflag_n(iib, outval);
      if (ipc->set & IIB_FLAG_Z)
        compile_stdflag_z(iib, outval);

      compile_eastore(iib, ipc, tp_src, srcreg, outval);
      break;

    case i_EXG:
      compile_ea(iib, ipc, tp_src, 1, &srcreg, -1);
      compile_eaval(iib, ipc, tp_src, srcreg, &srcval, -1);
      compile_ea(iib, ipc, tp_dst, 1, &dstreg, -1);
      compile_eaval(iib, ipc, tp_dst, dstreg, &dstval, -1);
      compile_adstore(iib, ipc, tp_dst, srcval);
      compile_adstore(iib, ipc, tp_src, dstval);
      break;

/* i_TST, i_TAS, i_CHK */

    case i_TST:
      compile_ea(iib, ipc, tp_src, 1, &srcreg, -1);
      compile_eaval(iib, ipc, tp_src, srcreg, &srcval, -1);

      if (ipc->set & IIB_FLAG_V)
        compile_clrflag_v(iib);
      if (ipc->set & IIB_FLAG_C)
        compile_clrflag_c(iib);
      if (ipc->set & IIB_FLAG_N)
        compile_stdflag_n(iib, srcval);
      if (ipc->set & IIB_FLAG_Z)
        compile_stdflag_z(iib, srcval);
      break;

    case i_TAS:
      compile_ea(iib, ipc, tp_src, 1, &srcreg, -1);
      compile_eaval(iib, ipc, tp_src, srcreg, &srcval, -1);

      outval = 4;
      OPCODE = ori(outval, srcval, 0x80);

      if (ipc->set & IIB_FLAG_V)
        compile_clrflag_v(iib);
      if (ipc->set & IIB_FLAG_C)
        compile_clrflag_c(iib);
      if (ipc->set & IIB_FLAG_N)
        compile_stdflag_n(iib, srcval);
      if (ipc->set & IIB_FLAG_Z)
        compile_stdflag_z(iib, srcval);

      compile_eastore(iib, ipc, tp_src, srcreg, outval);
      break;

