/*
 * m68k.h
 */

#ifndef M68K
#define M68K

/* Dn               :
 * An               :
 *
 * (An)             :
 * (An)+            :
 * -(An)            :
 * (d16,An)         :
 *
 * (d8,An,Xn)       :
 * (bd,An,Xn)       :
 *
 * ([bd,An],Xn,od)  :
 * ([bd,An,Xn],od)  :
 *
 * (d16,PC)         :
 *
 * (d8,PC,Xn)       :
 * (bd,PC,Xn)       :
 *
 * ([bd,PC],Xn,od)  :
 * ([bd,PC,Xn],od)  :
 *
 * (xxx).W          :
 * (xxx).L          :
 *
 * #<xxx>           :
 */

#define SUB    (0x9000)

#define SUB_B  (SUB | 0x0000)
#define SUB_W  (SUB | 0x0040)
#define SUB_L  (SUB | 0x0080)

#define SUB_DREG_B(s,d) (SUB_B | ((d & 7) << 9) | (s & 7))
#define SUB_DREG_W(s,d) (SUB_W | ((d & 7) << 9) | (s & 7))
#define SUB_DREG_L(s,d) (SUB_L | ((d & 7) << 9) | (s & 7))


#define ADD    (0xD000)

#define ADD_B  (ADD | 0x0000)
#define ADD_W  (ADD | 0x0040)
#define ADD_L  (ADD | 0x0080)

#define ADD_DREG_B(s,d) (ADD_B | ((d & 7) << 9) | (s & 7))
#define ADD_DREG_W(s,d) (ADD_W | ((d & 7) << 9) | (s & 7))
#define ADD_DREG_L(s,d) (ADD_L | ((d & 7) << 9) | (s & 7))


#define DIVS_W (0x81C0)
#define DIVU_W (0x80C0)

#define DIVS_DREG_W(s,d) (DIVS_W | ((d & 7) << 9) | (s & 7))
#define DIVU_DREG_W(s,d) (DIVU_W | ((d & 7) << 9) | (s & 7))

/*
  SUB_DREG_B(0, 1),
  SUB_DREG_W(0, 1),
  SUB_DREG_L(0, 1),

  ADD_DREG_B(0, 1),
  ADD_DREG_W(0, 1),
  ADD_DREG_L(0, 1),

  DIVS_DREG_W(0, 1),
  DIVU_DREG_W(0, 1),
*/

#endif
