/*****************************************************************************/
/*     Generator - Sega Genesis emulation - (c) James Ponder 1997-1998       */
/*****************************************************************************/
/*                                                                           */
/* compile.h                                                                 */
/*                                                                           */
/*****************************************************************************/

typedef struct compiler_s {
  /* Data */
  void *first;
  void *compiled;
  void *last;

  /* Functions */
  void (*go)(void);
  void (*compile)(void);
  void (*ram)(void);
  void (*autovector)(void);
  void (*bad)(void);
  void (*exit)(void);
} compiler_t;

compiler_t *compile_init(void);
void *compile_make(t_ipclist *list);
void compile_quit(void);
void compile_exit(void);

/* called by compiled code */
void *event_compiler_nextevent(void);
void event_compiler_catchup(void);
void *event_compiler_compile(void);
void event_compiler_ram(void);

